﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
namespace HeadFirst_07_DogRace
{
    /// <summary>
    ///  下注人类
    /// </summary>
    class Guy
    {
        public string Name;                                         //下注人姓名
        public Bet MyBet;                                           //赌注对象
        public int Cash;                                            //总金额

        public RadioButton MyRadioButton;
        public Label MyLabel;
        /// <summary>
        /// 更新投注人信息，投注对象信息
        /// </summary>
        public void UpDateLabel()
        {
            if (MyBet != null)
            {
                MyLabel.Text = Name + " bet's " + MyBet.Amount + " bucks on dog #" + MyBet.Dog;
                MyRadioButton.Text = Name + " has " + Cash + " bucks";
            }
            else
            {
                MyLabel.Text = Name + " hasn't palced a bet.";
                MyRadioButton.Text = Name + " has " + Cash + " bucks";
            }
        }
        /// <summary>
        /// 清除赌注
        /// </summary>
        public void ClearBet()
        {
            MyBet = null;
            UpDateLabel();
        }
        /// <summary>
        /// 生成投注
        /// </summary>
        /// <param name="Amount">金额</param>
        /// <param name="Dog">赛狗编号</param>
        public void PlaceBet(int Amount, int Dog)
        {
            if (Amount <= Cash && Amount > 0)
            {
                MyBet = new Bet() { Amount = Amount, Dog = Dog};
            }
            else
            {
                MessageBox.Show(Name + " 没有 " + Amount + "$ 投注给 #" + Dog);
            }
        }
        /// <summary>
        /// 结算比赛后金额
        /// </summary>
        /// <param name="Winner">胜利者</param>
        public void Collect(int Winner)
        {
            if (MyBet == null) return;
            Cash += MyBet.PayOut(Winner);
        }
    }
}
